> For the complete documentation index, see [llms.txt](https://docs.sunflower-land.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.sunflower-land.com/contributing/portals-ugc/mmo-server.md).

# MMO Server

Do you want player interaction inside of your Portal? This can be useful for mini-games that require co-operation or chat features.

## Setup

To connect to Sunflower Land MMO server, you must first update your `.env` file

```properties
VITE_API_URL=https://api-dev.sunflower-land.com
VITE_ROOM_URL=wss://mmo-dev.sunflower-land.com
```

Next you must ensure that a valid JWT is present from the player, see [Portal APIs](/contributing/portals-ugc/portal-apis.md#setup-and-authorisation)

## Connect to Server

We use `colyseus` to manage MMO connections inside of the game. See the example below in `portalMachine.ts` as to how the Crop Boom minigame creates a server connection.

```typescript
          // Join the MMO Server
          let mmoServer: Room<PlazaRoomState> | undefined;
          const serverName = getServer();
          const mmoUrl = CONFIG.ROOM_URL;

          if (serverName && mmoUrl) {
            const client = new Client(mmoUrl);

            mmoServer = await client?.joinOrCreate<PlazaRoomState>(serverName, {
              jwt: context.jwt,
              bumpkin: game?.bumpkin,
              farmId,
              x: SPAWNS.portal_example.default.x,
              y: SPAWNS.portal_example.default.y,
              sceneId: "portal_example",
              experience: game.bumpkin?.experience ?? 0,
            });
          }
```

Once you have established a server connection, you must pass this `mmoServer` into your Phaser initialisation.

```typescriptreact
game.current.registry.set("mmoServer", portalState.context.mmoServer);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.sunflower-land.com/contributing/portals-ugc/mmo-server.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
